const express = require('express')
const http = require('http')
const path = require('path')
const fs = require('fs');
const dgram = require('dgram');
const dotenv  = require('dotenv');
const app = express()
const bodyParser = require('body-parser'); //



dotenv.config({
    path: path.resolve(
      process.cwd(),
      process.env.NODE_ENV == "production" ? ".env" : ".env.dev"
    )
});

const server = dgram.createSocket('udp4');
// socket 실행
server.bind(9400);

server.on('listening', function() {
    console.log('Socket Port : 9400');
});


server.on('message', function(msg, rinfo) {
    udpResultMsg =  msg.toString();
});

server.on('close', function() {
    console.log('Server UDP Socket close');
});

const client = dgram.createSocket('udp4');
const clientPort= 9300;
//  const clientPort= 4403;

// const clientHost = '192.168.52.122'; //inet
const clientHost ='127.0.0.1';

// Error [ERR_SOCKET_DGRAM_NOT_RUNNING]: Not running 
client.on('close', function() {
    console.log('Client UDP socket close')
});

const jsonFile = fs.readFileSync('./json/projects.json', 'utf8');
// console.log(jsonFile);

const jsonData = JSON.parse(jsonFile);

console.log(jsonData);

//Post 방식은 Get 과 다르기 때문에 body-parser 를 설치해서 사용해야한다.
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({extended: false}))

//vue router 연동하기 위한 설정
app.use(require('connect-history-api-fallback')());

app.use(express.static(path.join(__dirname, 'public')));

app.set('port',process.env.PORT || 3000);

/* udp 통신으로 매니저에게 받는 결과값*/
let udpResultMsg = ''
/* udp 통신 기다리는 시간*/
let udpAwaitTime = 0

let newProjectNum = 0

//json 파일 불러오기
app.get('/api/getProjectList',(req,res) => {
    res.send(jsonData)
})

//USER - 검수 완료후 티칭 정보 수정
app.post('/api/teachingInfoModify',(req,res) => {
    console.log("수정할 번호 req.body.project_num :"+ req.body.project_num)
    fs.readFile('./json/projects.json', 'utf8',(err ,data) => {
        let showData = JSON.parse(data)
        for(var key in showData){
            if(showData[key].project_num === req.body.project_num){
                if(req.body.result){
                    showData[key].current_done++
                }else{
                    showData[key].current_reject++
                }
                showData[key].current_counter++
            }
        }
        fs.writeFile('./json/projects.json', JSON.stringify(showData), (err)=>{
            if (err) throw err;
            console.log('JSON File Update Complete');
        });
    })
    
}),

//ADMIN - project 새 번호 가져오기 : 캡처 이미지 이름과  프로젝트 생성하기 위함
app.get('/api/projectCreateNum',(req,res) => {
    fs.readFile('./json/project_num_seq.json', 'utf8', (err ,data) => {
        let showData = JSON.parse(data)
        newProjectNum = ++showData[0].project_num_seq
        console.log("newProjectNum : ",newProjectNum)
        if(err)
        console.error("읽어오기 실패")
        res.json(newProjectNum)
    });
}),

// ADMIN - 프로젝트 생성
app.post('/api/projectCreate',(req,res) => {
    console.log(" ------------------------- ")
    console.log(" 메시지 뭐냐? ",req.body)
    console.log(" ------------------------- ")

    fs.readFile('./json/projects.json', 'utf8',(err ,data) => {
        let showData = JSON.parse(data)
        let retrunMsg  = ''
        showData[newProjectNum-1] = {
            project_num: newProjectNum,
            project_name: req.body.project.project_name,
            total_num: req.body.project.total_num,
            project_user: req.body.project.project_user,
            project_admin: req.body.project.project_admin,
            current_counter: req.body.project.current_counter,
            current_done: req.body.project.current_done,
            current_reject: req.body.project.current_reject,
            image_path: req.body.project.image_path,
            start_date: req.body.project.start_date,
            end_date: req.body.project.end_date,
            project_state: '',
            success_teaching:req.body.successRect,
            fail_teaching:req.body.failRect
        },

        retrunMsg = `${req.body.project_name} 저장 되었습니다.`

        console.log('showData :' ,showData)
        console.log("newProjectNum :",newProjectNum)

        fs.writeFile('./json/projects.json', JSON.stringify(showData), (err)=>{
            if (err) throw res.send(err)
            console.log('"projects.json" File Update Complete');
            // res.status(200)
            res.send( {result:true ,project_num:newProjectNum })
        });

        fs.readFile('./json/project_num_seq.json', 'utf8',(err ,data) => {
            let showData = JSON.parse(data)

            console.log('RESULT newProjectNum :' ,newProjectNum)
            console.log('RESULT showData :' ,showData[0].project_num_seq)

            showData[0].project_num_seq = newProjectNum
    
            fs.writeFile('./json/project_num_seq.json', JSON.stringify(showData), (err)=>{
                if (err) throw res.send(err)
                console.log('"project_num_seq.json" File Update Complete');
            });
        })
    })
})

//ADMIN - project 상태 (삭제 ,수정 )변경
app.post('/api/projectUpdate',(req,res) => {
    console.log(" ------------------------- ")
    console.log(" projectUpdate : ? ",req.body.msg)
    console.log(" ------------------------- ")
    fs.readFile('./json/projects.json', 'utf8',(err ,data) => {
        let showData = JSON.parse(data)
        let retrunMsg  = ''
        for(var key in showData){
            if(showData[key].project_num === req.body.project_num){
                if(req.body.msg === "remove"){
                    showData[key].project_state = "req.body.msg"
                    retrunMsg = `${req.body.project_name} 삭제 되었습니다.`
                }else if(req.body.msg === "update"){
                    showData[key].project_admin = req.body.project_admin
                    showData[key].project_user = req.body.project_user
                    showData[key].total_num = req.body.total_num
                    showData[key].start_date = req.body.start_date
                    showData[key].end_date = req.body.end_date
                    retrunMsg = `${req.body.project_name} 수정 되었습니다.`
                }else {
                    res.send(err)
                }
            }
        }
        fs.writeFile('./json/projects.json', JSON.stringify(showData), (err)=>{
            if (err) throw res.send(err)
            console.log('JSON File Update Complete');
            // res.status(200)
            res.send(retrunMsg)
        });
    })
})

const wrapper = asyncFn => { return (async (req, res, next) => { try { return await asyncFn(req, res, next); } catch (error) { return next(error); } }); };

//https://kjwsx23.tistory.com/199 express 와 async ,await 이슈
//express async await wrapper 함수를 써서 감싸거나 라이브러리를 써야 한다. 
app.get('/api/requestManager',wrapper(async (req,res)=>{
    
    req.query.image_path = process.env.TEACHING_IMAGE_PATH
    
    if(req.query.cmd === "neuro_check") req.query.teaching = `${process.env.TEACHING_IMAGE_PATH}-test-2-${process.env.TEACHING_RESOLUTION}-${req.query.teaching_info}`

    //req.query.project_num
    console.log("param :",JSON.stringify(req.query) )

    sendToManager (JSON.stringify(req.query))

    let requestMsg = ''

    switch(req.query.cmd){
        case "neuro_start":
            requestMsg = 'neuro_start_done'
            break
        case "neuro_ready": 
            requestMsg = 'neuro_ready_done'
            break 
        case "neuro_capture": 
            requestMsg = 'capture_done'
            break 
        case "neuro_check" :
            requestMsg = 'neuro_result'
            break           
        default:
            res.status(404)
    }

    await responseManager(requestMsg)
        .then(data => {
            res.status(200).json(data)
        })
        .catch(error =>{
            res.status(404).send(error);
        })
}))

//UDP 메세지 보냄 통신
function sendToManager(msg){
    client.send(msg, 0, msg.length, clientPort, clientHost, function(err) {
        if ( err ) return ; 
        console.log("UDP send Msg ")
    });
}

// await Promise 응답해야됨
function responseManager (requestMsg) {
   return new Promise((resolve, reject) => {
        let delay = 100; //ms 단위로 체크
        let waitingTime = 0 //대기 시간 
 
        let timer = setInterval(() => {
            if(requestMsg === JSON.parse(udpResultMsg).cmd ){
                console.log(`json 데이터는 ? ${JSON.parse(udpResultMsg).cmd}`)
                resolve(udpResultMsg)
                clearInterval(timer)
            }else if(waitingTime === 5000){
                reject('No response from Manager')
                clearInterval(timer)
            }else{
                waitingTime = waitingTime + delay
            }
        },delay)
    });
}
 
http.createServer(app).listen(app.get('port'),function(){
    console.log('WebServer Port: ' +app.get('port'))
})
